#!/bin/bash
#	fswatch の出力を分析いたします
#
#	fswatch_analyze 	Createされたファイルの一覧
#	
#
CMD=`basename $0`
TMP=/tmp/$CMD.$$
MODE=list
EXECUTE=cat
FILE=
while [ "$1" != "" ]
do
	case $1 in
	-l)	
		MODE=list
		OPTION=$2
		echo "検索文字列[$OPTION]"
		REJECT=
		EXECUTE=cat
		shift
		;;
	-r)	MODE=remove
		OPTION='Created|Renamed'
		REJECT='Renamed'
		EXECUTE=remove
		;;
	-c)	MODE=list
		OPTION='Created|Renamed'
		REJECT='Renamed'
		FOLDER=$2
		shift
		if [ -z $FOLDER ];then
			echo "Please specify new folder name"
			exit 6
		fi
		if [ -d $FOLDER ];then
			echo "$FOLDER already exist."
			exit 5
		fi
		EXECUTE="cpio -pmd $FOLDER > $TMP"
		;;
	-h)
	cat<<@
$CMD -l 検索文字列	List files with 検索文字列
$CMD -c パス		Copy 作成された files into new folder named パス
$CMD -r			Remove 作成された files
@
		exit 0
		;;
	-*)
		echo "Unknown option $1. Type $CMD -h"
		exit 3
		;;
	"")
		;;
	*)
		FILE=$1
		echo "Open file [$FILE]"
		;;
	esac
	shift
done
#
action(){
	case $MODE in
	list)
		printf "%s\n" $1
		;;
	remove)
		#Removeの場合、IsDir は最後に実行する
		if [ "$2" == "IsDir" ];then
			printf "1 %s\n" $1
		else
			printf "0 %s\n" $1
		fi
		;;
	esac
}
#
remove(){
	while read ID FILE
	do
		if [ $ID -eq 0 ];then
			sudo rm $FILE
		else
			sudo rmdir $FILE
		fi
	done
}
#
if [ -z $FILE ];then
	echo "Enter file list."
fi
cat $FILE|
(
while read FILE ACTION ETC
do
	ETC_ARRAY=($ETC)
	(( _i = ${#ETC_ARRAY[*]} - 1 ))
	case "$OPTION" in
	all)	printf "%s %s %s\n" $FILE $ACTION "$ETC"
		;;
	*)	if [[ $ACTION =~ $OPTION ]];then
			if [ -z $REJECT ];then
				action $FILE ${ETC_ARRAY[$_i]}
			else
				if [[ ! "$ETC" =~ .*$REJECT.*  ]];then
					action $FILE ${ETC_ARRAY[$_i]}
				fi
			fi
		fi
		;;
	esac
done
)|sort|uniq|eval $EXECUTE
